# InitialValues.jl: Canonical default initial values and identity elements for Julia

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliafolds.github.io/InitialValues.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliafolds.github.io/InitialValues.jl/dev)
[![GitHub Actions](https://github.com/JuliaFolds/InitialValues.jl/workflows/Run%20tests/badge.svg)](https://github.com/JuliaFolds/InitialValues.jl/actions?query=workflow%3ARun+tests)
[![Codecov](https://codecov.io/gh/JuliaFolds/InitialValues.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaFolds/InitialValues.jl)
[![Coveralls](https://coveralls.io/repos/github/JuliaFolds/InitialValues.jl/badge.svg?branch=master)](https://coveralls.io/github/JuliaFolds/InitialValues.jl?branch=master)
[![Aqua QA](https://img.shields.io/badge/Aqua.jl-%F0%9F%8C%A2-aqua.svg)](https://github.com/tkf/Aqua.jl)

InitialValues.jl provides a generic singleton initial value `InitialValue(f)`
that can be used as `a₀` in `f(a₀, x)`.  For a binary operator `op`,
it means that `InitialValue(op)` acts like the identity for _any_ type of `x`:

```julia
julia> using InitialValues

julia> InitialValue(+) + 1
1

julia> 1.0 + InitialValue(+)
1.0

julia> foldl(+, 1:3, init=InitialValue(+))
6
```

Following methods are defined for the binary operators in `Base`:

```julia
julia> InitialValue(*) * 1
1

julia> InitialValue(&) & 1
1

julia> InitialValue(|) | 1
1

julia> min(InitialValue(min), 1)
1

julia> max(InitialValue(max), 1)
1

julia> Base.add_sum(InitialValue(Base.add_sum), 1)
1

julia> Base.mul_prod(InitialValue(Base.mul_prod), 1)
1
```

`InitialValue` is not called `Identity` because it is useful to define it for
functions that are not binary operator (symmetric in signature).  For
example, `push!!` in [BangBang.jl](https://github.com/JuliaFolds/BangBang.jl)
defines

``````julia
julia> using BangBang

julia> push!!(InitialValue(push!!), 1)
1-element Array{Int64,1}:
 1
``````

This provides a powerful pattern when combined with `foldl`:

``````julia
julia> foldl(push!!, (1, missing, 2.0), init=InitialValue(push!!))
3-element Array{Union{Missing, Float64},1}:
 1.0
  missing
 2.0
``````

[Transducers.jl](https://github.com/JuliaFolds/Transducers.jl) extensively
uses `InitialValue`.

As binary operators like `*` in `Base` are heavily overloaded,
creating generic definitions such as above could have introduced
method ambiguities.  To protect against such situation, InitialValues.jl is
tested using [Aqua.jl](https://github.com/tkf/Aqua.jl).

module TestSingleton

using InitialValues: Singleton
using Test

@testset begin
    s = Singleton(nothing)
    @test ndims(s) == 0
    @test ndims(typeof(s)) == 0
    @test size(s) == ()
    @test axes(s) == ()
    @test length(s) == 1
    @test eltype(s) === Nothing
    @test s[] === nothing
    @test s[CartesianIndex()] === nothing
    @test collect(s)::Vector{Nothing} == [nothing]
end

end  # module

using Documenter, InitialValues

makedocs(;
    modules=[InitialValues],
    format=Documenter.HTML(),
    pages=[
        "Home" => "index.md",
    ],
    repo="https://github.com/JuliaFolds/InitialValues.jl/blob/{commit}{path}#L{line}",
    sitename="InitialValues.jl",
    authors="Takafumi Arakaki <aka.tkf@gmail.com>",
    strict = true,
)

deploydocs(;
    repo="github.com/JuliaFolds/InitialValues.jl",
    push_preview = true,
)

module TestAqua

import Setfield
using Aqua
using BangBang
using InitialValues
using Test

Aqua.test_all(InitialValues)

@testset "Test ambiguities with `BangBang`" begin
    if v"1.6.0-DEV.816" <= VERSION < v"1.6.0-DEV.875"
        # Maybe remove this branch?
        @warn "Ignoring ambiguities from `Base` to workaround JuliaLang/julia#36962"
        packages = [InitialValues, BangBang]
    else
        packages = [InitialValues, BangBang, Base]
    end
    Aqua.test_ambiguities(packages; exclude = [Base.get, Setfield.set, Setfield.modify])
end

@testset "Compare test/Project.toml and test/environments/main/Project.toml" begin
    @test Text(read(joinpath(@__DIR__, "Project.toml"), String)) ==
          Text(read(joinpath(@__DIR__, "environments", "main", "Project.toml"), String))
end

end  # module

pprint(io, x) = print(io, x)
function pprint(io, x::Expr)
    if x.head == :block
        args = [a for a in x.args if !(a isa LineNumberNode)]
        if length(args) == 1
            pprint(io, args[1])
        else
            for (i, a) in enumerate(args)
                i == 1 || println(io)
                pprint(io, a)
            end
        end
    elseif x.head == :(=)
        @assert length(x.args) == 2
        pprint(io, x.args[1])
        print(io, " = ")
        pprint(io, x.args[2])
    else
        print(io, x)
    end
end

prettyexpr(x) = sprint(pprint, x)

module TestBasics

using Test
using InitialValues
using InitialValues: isknown, hasinitialvalue

OPS = [*, +, |, &, min, max, Base.add_sum, Base.mul_prod]

@testset for op in OPS
    @test op(InitialValue(op), :anything) === :anything
    @test op(:anything, InitialValue(op)) === :anything
    @test op(INIT, :anything) === :anything
    @test op(:anything, INIT) === :anything
    @test hasinitialvalue(op)
    @test hasinitialvalue(typeof(op))
    @test isknown(InitialValue(op))
end

@testset "show" begin
    @testset "$desired" for (op, desired) in [
        (+, "InitialValue(+)"),
        (*, "InitialValue(*)"),
        (|, "InitialValue(|)"),
        (&, "InitialValue(&)"),
        (min, "InitialValue(min)"),
        (max, "InitialValue(max)"),
    ]
        @test repr(InitialValue(op); context=:limit => true) == desired
        @test repr(InitialValue(op)) == "InitialValues.$desired"
        @test string(InitialValue(op)) == "InitialValues.$desired"
    end
    @testset "INIT" begin
        @test repr(INIT; context=:limit => true) == "INIT"
        @test repr(INIT) == "InitialValues.INIT"
        @test string(INIT) == "InitialValues.INIT"
    end
end

@testset "hasinitialvalue" begin
    @test !hasinitialvalue(-)
    @test !hasinitialvalue(typeof(-))
    @test !hasinitialvalue(Int)
    @test !hasinitialvalue(Type{Int})
end

@testset "missing" begin
    @test min(InitialValue(min), missing) === missing
    @test max(InitialValue(max), missing) === missing
end

@testset "promote" begin
    for op in OPS
        T = typeof(InitialValue(op))
        @test promote_type(T, Val{0}) == Union{T,Val{0}}
    end
end

@testset "convert" begin
    @testset "float" begin
        @test float(InitialValue(+)) === 0.0
        @test float(InitialValue(*)) === 1.0
        @test float(InitialValue(Base.add_sum)) === 0.0
        @test float(InitialValue(Base.mul_prod)) === 1.0
    end
    @testset "Integer" begin
        @test Integer(InitialValue(+)) === 0
        @test Integer(InitialValue(*)) === 1
        @test Integer(InitialValue(Base.add_sum)) === 0
        @test Integer(InitialValue(Base.mul_prod)) === 1
    end
    @testset for T in [
        Int,
        UInt8,
        Float64,
        Float32,
    ]
        @test convert(T, InitialValue(+))::T == 0
        @test convert(T, InitialValue(*))::T == 1
        @test convert(T, InitialValue(Base.add_sum))::T == 0
        @test convert(T, InitialValue(Base.mul_prod))::T == 1
    end

    @test convert(String, InitialValue(*)) === ""
end

@testset "asmonoid" begin
    absmin = asmonoid() do a, b
        abs(a) < abs(b) ? a : b
    end
    @test absmin(InitialValue(absmin), Inf) === Inf
    @test absmin(missing, InitialValue(absmin)) === missing
    @test absmin(InitialValue(absmin), InitialValue(absmin)) === InitialValue(absmin)
    @test hasinitialvalue(absmin)
    @test hasinitialvalue(typeof(absmin))
    @test isknown(InitialValue(absmin))

    @test asmonoid(+) === +

    @test_throws Union{ArgumentError,MethodError} Base.reduce_empty(absmin, Int)
end

end  # module

module TestInitialValues
using Test

@testset "$file" for file in sort([file for file in readdir(@__DIR__) if
                                   match(r"^test_.*\.jl$", file) !== nothing])
    include(file)
end

@testset "$file" for file in sort([
    file for file in readdir(joinpath(@__DIR__, "interop"))
    if match(r"^test_.*\.jl$", file) !== nothing
])
    include(joinpath("interop", file))
end

end  # module

module TestBangBang

using Test
using BangBang
using InitialValues: InitialValue, hasinitialvalue

@testset begin
    @test hasinitialvalue(push!!)
    @test hasinitialvalue(append!!)
    @test push!!(InitialValue(push!!), 1) == [1]
    @test append!!(InitialValue(append!!), [1]) == [1]
    @test append!!([1], InitialValue(append!!)) == [1]
end

@testset "promote" begin
    init = InitialValue(+)
    @test eltype(push!!([init], 0)) == Union{typeof(init),Int}
end

end  # module

module TestPrettyExpr

using Test
using InitialValues: prettyexpr, def_impl, disambiguate_impl

parseall(code) = Meta.parse("begin $code end")

roundtrip(code::AbstractString) = prettyexpr(parseall(code))
roundtrip(ex::Expr) = parseall(prettyexpr(ex))

isalnn(x) = x isa LineNumberNode

normalize(x) = x
function normalize(x::Expr)
    args = normalize.(filter(!isalnn, x.args))
    if x.head == :block && length(args) == 1
        return args[1]
    end
    return Expr(x.head, args...)
end

eq(x, y) = normalize(x) == normalize(y)

@testset "$label" for (label, ex) in [
    (
        label = "f(x) = x",
        ex = :(f(x) = x),
    ),
    (
        label = "def_impl",
        ex = def_impl(:op, :x, :y),
    ),
    (
        label = "disambiguate_impl",
        ex = disambiguate_impl(:op, :RightType, :x),
    ),
]
    code = prettyexpr(ex)
    @test roundtrip(code) === code
    @test eq(roundtrip(ex), ex)
end

end  # module

module TestBroadcasting

using Test
using InitialValues

OPS = [*, +, |, &, min, max, Base.add_sum, Base.mul_prod]

@testset for op in OPS
    @test op.(InitialValue(op), 1:3) == 1:3
end

@testset "binary op" begin
    @test InitialValue(+) .+ (1:3) == 1:3
    @test InitialValue(*) .* (1:3) == 1:3
    @test InitialValue(|) .| (1:3) == 1:3
    @test InitialValue(&) .& (1:3) == 1:3
end

end  # module

# See also https://github.com/JuliaLang/julia/pull/35778

struct Singleton{T}
    value::T
end

Base.ndims(::Singleton) = 0
Base.ndims(::Type{<:Singleton}) = 0
Base.size(::Singleton) = ()
Base.axes(::Singleton) = ()
Base.length(::Singleton) = 1
Base.eltype(::Type{Singleton{T}}) where {T} = T
Base.getindex(s::Singleton) = s.value
Base.getindex(s::Singleton, ::CartesianIndex{0}) = s.value
Base.iterate(s::Singleton) = (s.value, nothing)
Base.iterate(::Singleton, ::Nothing) = nothing

Base.IteratorSize(::Type{<:Singleton}) = Base.HasLength()
Base.IteratorEltype(::Type{Singleton{T}}) where {T} = Base.HasEltype()

module InitialValues

# Use README as the docstring of the module:
@doc let path = joinpath(dirname(@__DIR__), "README.md")
    include_dependency(path)
    replace(read(path, String), r"^```julia"m => "```jldoctest README")
end InitialValues

export INIT, InitialValue, asmonoid

include("prettyexpr.jl")
include("broadcastable.jl")

abstract type InitialValue end
abstract type SpecificInitialValue{OP} <: InitialValue end
abstract type NonspecificInitialValue <: InitialValue end

"""
    InitialValue(OP)

Create a generic (left) identity for a binary operator `op`.  For
general binary function, it provides an identity-like generic default
value (see `BangBang.push!!`).

# Examples
```jldoctest
julia> using InitialValues

julia> InitialValue(*) isa InitialValues.InitialValue
true

julia> InitialValue(*) * 1
1

julia> InitialValue(*) * missing
missing

julia> InitialValue(*) * "right"
"right"

julia> InitialValue(*) * :actual_anything_works
:actual_anything_works

julia> foldl(+, 1:3, init=InitialValue(+))
6

julia> float(InitialValue(*))
1.0

julia> Integer(InitialValue(+))
0
```
"""
InitialValue(::OP) where {OP} = InitialValueOf{OP}()
@deprecate Init(op) InitialValue(op)

struct TypeOfINIT <: NonspecificInitialValue end

"""
    INIT :: InitialValue

A generic initial value.  Unlike [`InitialValue`](@ref), this does not detect
an error when `INIT` is used with unintended operations.

# Examples
```jldoctest
julia> using InitialValues

julia> InitialValue(+) * 0  # `InitialValue(op)` must be used with `op`
ERROR: MethodError: no method matching *(::InitialValues.InitialValueOf{typeof(+)}, ::Int64)
[...]

julia> INIT * 123
123

julia> foldl(+, 1:3, init=INIT)
6
```
"""
const INIT = TypeOfINIT()

function Base.show(io::IO, ::TypeOfINIT)
    if !get(io, :limit, false)
        # Don't show full name in REPL etc.:
        print(io, "InitialValues.")
    end
    print(io, "INIT")
end

struct InitialValueOf{OP} <: SpecificInitialValue{OP} end

const GenericInitialValue{OP} = Union{SpecificInitialValue{OP},NonspecificInitialValue}

function Base.show(io::IO, ::InitialValueOf{OP}) where {OP}
    if !get(io, :limit, false)
        # Don't show full name in REPL etc.:
        print(io, "InitialValues.")
    end
    op = string(OP)
    if startswith(op, "typeof(") && endswith(op, ")")
        print(io, "InitialValue(", op[length("typeof(") + 1 : end - length(")")], ")")
    else
        print(io, "InitialValue(::", op, ")")
    end
end

itypeof_impl(op) = :(GenericInitialValue{typeof($op)})
@eval itypeof(op) = $(itypeof_impl(:op))

"""
    InitialValues.hasinitialvalue(op) :: Bool

# Examples
```jldoctest
julia> using InitialValues

julia> all(InitialValues.hasinitialvalue, [
           *,
           +,
           &,
           |,
           min,
           max,
           Base.add_sum,
           Base.mul_prod,
       ])
true

julia> InitialValues.hasinitialvalue((x, y) -> x + y)
false
```
"""
hasinitialvalue(::OP) where OP = hasinitialvalue(OP)
hasinitialvalue(::Type) = false

"""
    InitialValues.isknown(::InitialValue) :: Bool

# Examples
```jldoctest
julia> using InitialValues

julia> InitialValues.isknown(InitialValue(+))
true

julia> InitialValues.isknown(InitialValue((x, y) -> x + y))
false
```
"""
isknown(::SpecificInitialValue{OP}) where OP = hasinitialvalue(OP)

def_impl(op, x, y) =
    quote
        $op(::$(itypeof_impl(op)), $x) = $y
        InitialValues.hasinitialvalue(::Type{typeof($op)}) = true
    end

def_monoid_impl(op, x) =
    quote
        $op(::$(itypeof_impl(op)), $x::$(itypeof_impl(op))) = $x
        $op($x, ::$(itypeof_impl(op))) = $x
        $(def_impl(op, x, x))
    end

"""
    InitialValues.@def op [y = :x]

Define a generic (left) identity for a binary operator `op`.  Specify
the second argument for a binary function in general.

`InitialValues.@def op` is expanded to

```julia
$(prettyexpr(def_impl(:op, :x, :x)))
```

For operations like `push!`, it is useful to define the returned value
to be different from `x`.  This can be done by using the second
argument to the maco; i.e., `InitialValues.@def push! [x]` is expanded to

```julia
$(prettyexpr(def_impl(:push!, :x, "[x]")))
```

Note that the second argument to `op` is always `x`.
"""
macro def(op, y = :x)
    def_impl(esc(op), esc(:x), esc(y))
end

"""
    InitialValues.@def_monoid op

Define a generic identity for a binary operator `op`.
`InitialValues.@def_monoid op` is expanded to

```julia
$(prettyexpr(def_monoid_impl(:op, :x)))
```
"""
macro def_monoid(op)
    def_monoid_impl(esc(op), esc(:x))
end

disambiguate_impl(op, other, x) =
    quote
        $op(::$(itypeof_impl(op)), $x::$other) = $x
        $op($x::$other, ::$(itypeof_impl(op))) = $x
    end

"""
    InitialValues.@disambiguate op OtherType

Disambiguate the method introduced by [`@def_monoid`](@ref).

It is expanded to

```julia
$(prettyexpr(disambiguate_impl(:op, :OtherType, :x)))
```
"""
macro disambiguate(op, other)
    disambiguate_impl(esc(op), esc(other), esc(:x))
end

@def_monoid Base.:*
@def_monoid Base.:+
@def_monoid Base.:&
@def_monoid Base.:|
@def_monoid Base.min
@def_monoid Base.max
@def_monoid Base.add_sum
@def_monoid Base.mul_prod

@disambiguate Base.min Missing
@disambiguate Base.max Missing

Base.promote_rule(::Type{I}, ::Type{S}) where {I<:InitialValue,S} = Union{I,S}
if VERSION < v"1.3"
    Base.promote_rule(::Type{I}, ::Type{Any}) where {I<:InitialValue} = Any
end

const ZeroType = Union{
    SpecificInitialValue{typeof(+)},
    SpecificInitialValue{typeof(Base.add_sum)},
}
const OneType = Union{
    SpecificInitialValue{typeof(*)},
    SpecificInitialValue{typeof(Base.mul_prod)},
}

Base.float(::ZeroType) = 0.0
Base.float(::OneType) = 1.0
Base.Integer(::ZeroType) = 0
Base.Integer(::OneType) = 1

Base.convert(::Type{T}, ::ZeroType) where {T <: Number} = zero(T)
Base.convert(::Type{T}, ::OneType) where {T <: Union{Number, AbstractString}} =
    one(T)

# Technically true, but could be a disaster in practice?:
#=
Base.convert(::Type{T}, ::Union{SpecificInitialValue{typeof(min)}}) where {T <: Number} =
    typemax(T)

Base.convert(::Type{T}, ::Union{SpecificInitialValue{typeof(max)}}) where {T <: Number} =
    typemin(T)
=#

struct AdjoinIdentity{T} <: Function
    op::T
end

"""
    asmonoid(op) -> op′

"Add" (adjoin) an identity element to the semigroup `op` if necessary
and return the monoid `op′`.

# Examples
```jldoctest
julia> using InitialValues

julia> asmonoid(*) === *  # do nothing if `InitialValue` is already defined
true

julia> append!′ = asmonoid(append!);

julia> xs = [];

julia> append!′(InitialValue(append!′), xs) === xs
true

julia> foldl(append!′, [xs, [1], [2, 3]], init=InitialValue(append!′))
3-element Array{Any,1}:
 1
 2
 3

julia> ans === xs  # `xs` is modified
true
```
"""
asmonoid(op) = hasinitialvalue(op) ? op : AdjoinIdentity(op)

(sg::AdjoinIdentity)(x, y) = sg.op(x, y)
(::AdjoinIdentity{OP})(::SpecificInitialValue{AdjoinIdentity{OP}}, x) where OP =
    x
(::AdjoinIdentity{OP})(x, ::SpecificInitialValue{AdjoinIdentity{OP}}) where OP =
    x
(::AdjoinIdentity{OP})(::SpecificInitialValue{AdjoinIdentity{OP}},
                       x::SpecificInitialValue{AdjoinIdentity{OP}}) where OP = x
hasinitialvalue(::Type{AdjoinIdentity{T}}) where {T} = true

Broadcast.broadcastable(init::InitialValue) = Singleton(init)

end # module

module TestDef

using Test
using InitialValues: InitialValue, hasinitialvalue, isknown

module CleanNameSpace
    using InitialValues: @def, @disambiguate
    add(x, y) = x + y
    got(x) = string("Got: ", repr(x))
    @def add got(x)
    @disambiguate add Missing
end

@testset "CleanNameSpace" begin
    add = CleanNameSpace.add
    @test !isdefined(CleanNameSpace, :InitialValues)
    @test hasinitialvalue(add)
    @test isknown(InitialValue(add))
    @test add(InitialValue(add), :x) == "Got: :x"
    @test add(InitialValue(add), missing) === missing
end

module NonFunction
    using InitialValues: @def, @disambiguate
    struct Add end
    const add = Add()
    add(x, y) = x + y
    @def add
    @disambiguate add Missing
end

@testset "NonFunction" begin
    add = NonFunction.add
    @test !(add isa Function)
    @test hasinitialvalue(add)
    @test isknown(InitialValue(add))
    @test add(InitialValue(add), :x) == :x
    @test add(InitialValue(add), missing) === missing
end

end  # module

# InitialValues.jl

```@index
```

```@docs
InitialValues
InitialValues.InitialValue
InitialValues.INIT
InitialValues.@def
InitialValues.@def_monoid
InitialValues.@disambiguate
InitialValues.hasinitialvalue
InitialValues.isknown
InitialValues.asmonoid
```
